## xc3sprog 0+svn795+dfsg

=== CMakeLists.txt ===
# Project
project(xc3sprog)
set(xc3sprog_VERSION_MAJOR 0)
set(xc3sprog_VERSION_MINOR 0)

SET(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}")
set(CMAKE_CXX_FLAGS "-g -Wall")
cmake_minimum_required(VERSION 2.6)

find_package(PkgConfig REQUIRED)

if(${WIN32})
set(USE_STATIC_FTDI ON)
IF( ${CMAKE_COMPILER_IS_GNUCXX} )
 # link libstdc++ and others statically
 add_definitions( -D__USE_MINGW_ANSI_STDIO )
 SET (CMAKE_EXE_LINKER_FLAGS    "-static-libstdc++ -static-libgcc")
ENDIF( ${CMAKE_COMPILER_IS_GNUCXX} )
endif(${WIN32})

option(USE_FTD2XX "Use FTDI libFTD2XX instead of free libftdi" ON)

pkg_check_modules(LIBFTDI REQUIRED libftdi1)
include_directories(${LIBFTDI_INCLUDE_DIRS})

if(USE_FTD2XX)
  find_package(libFTD2XX)
endif(USE_FTD2XX)

if(LIBFTD2XX_FOUND)
  include_directories(${LIBFTD2XX_INCLUDE_DIR})
  add_definitions( -DUSE_FTD2XX )
else(LIBFTD2XX_FOUND)
  set(LIBFTD2XX_LIBRARIES "")
endif(LIBFTD2XX_FOUND)

if(EXISTS ${PROJECT_SOURCE_DIR}/.git)
  set(VERSION_STRING "${xc3sprog_VERSION_MAJOR}.${xc3sprog_VERSION_MINOR}-git")
else(EXISTS ${PROJECT_SOURCE_DIR}/.git)
  FIND_PACKAGE(Subversion)
  IF(Subversion_FOUND AND EXISTS ${PROJECT_SOURCE_DIR}/.svn)
    Subversion_WC_INFO(${PROJECT_SOURCE_DIR} Project)
    set(VERSION_STRING "${xc3sprog_VERSION_MAJOR}.${xc3sprog_VERSION_MINOR}-svn${Project_WC_REVISION}")
  ELSE(Subversion_FOUND AND EXISTS ${PROJECT_SOURCE_DIR}/.svn)
    set(VERSION_STRING "unknown")
  ENDIF(Subversion_FOUND AND EXISTS ${PROJECT_SOURCE_DIR}/.svn)
endif(EXISTS ${PROJECT_SOURCE_DIR}/.git)

# Create suffix to eventually install inlib64
IF(CMAKE_SIZEOF_VOID_P EQUAL 4)
    SET(LIB_SUFFIX "")
    SET(PACK_ARCH ".x86")
  ELSE(CMAKE_SIZEOF_VOID_P EQUAL 8)
    SET(LIB_SUFFIX 64)
    SET(PACK_ARCH .x86_64)
endif(CMAKE_SIZEOF_VOID_P EQUAL 4)

# Package information
set(CPACK_PACKAGE_VERSION              ${VERSION_STRING})
set(CPACK_PACKAGE_CONTACT              "Uwe Bonnes <bon@elektron.ikp.physik.tu-darmstadt.de>")
set(CPACK_PACKAGE_DESCRIPTION          "JTAG Progarmming tools")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY  ${CPACK_PACKAGE_DESCRIPTION}
                                       )
# Package settings
if(${UNIX})
  set(CPACK_GENERATOR                    "DEB;RPM")
  set(CPACK_CMAKE_GENERATOR              "Unix Makefiles")
  set(CPACK_PACKAGE_NAME                 ${PROJECT_NAME})
  set(CPACK_PACKAGE_FILE_NAME            ${PROJECT_NAME}-${VERSION_STRING}${PACK_ARCH})
endif(${UNIX})

if(${WIN32})
  set(CPACK_GENERATOR                    "NSIS")
  set(CPACK_CMAKE_GENERATOR              "MinGW Makefiles")
  set(CPACK_PACKAGE_NAME                 "${PROJECT_NAME}")
  set(CPACK_PACKAGE_VENDOR               "")
  set(CPACK_PACKAGE_INSTALL_DIRECTORY    "libftdi")
  set(CPACK_PACKAGE_FILE_NAME            "${PROJECT_NAME}-${VERSION_STRING}-win32")
  set(CPACK_NSIS_DISPLAY_NAME            "libftdi")
  set(CPACK_NSIS_MODIFY_PATH             "ON")
endif(${WIN32})

set(CPACK_RESOURCE_FILE_LICENSE        ${CMAKE_SOURCE_DIR}/LICENSE)

set(CPACK_SOURCE_GENERATOR             TGZ)
set(CPACK_SOURCE_IGNORE_FILES          "\\\\.svn" "build*")
set(CPACK_SOURCE_PACKAGE_FILE_NAME     ${CPACK_PACKAGE_FILE_NAME})

# Subdirectories
if(${UNIX})
  set(CPACK_SET_DESTDIR "ON")
endif(${UNIX})

#link libusb dynamic at runtime on windows at at compile time else
#this circumvents a problem with Debian
set (CONDITIONAL_FILES)
set (CONDITIONAL_LIBS)
if("${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
   set (CONDITIONAL_FILES ${CONDITIONAL_FILES} "libusb_dyn.c")
else("${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
   pkg_check_modules(LIBUSB_COMPAT REQUIRED libusb)
   include_directories(${LIBUSB_INCLUDE_DIRS})
   set(CONDITIONAL_LIBS ${CONDITIONAL_LIBS} usb usb-1.0)

endif("${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")

if(NOT "${CMAKE_SYSTEM_NAME}" STREQUAL "Darwin")
        set (CONDITIONAL_FILES ${CONDITIONAL_FILES} "ioparport.cpp")
endif(NOT "${CMAKE_SYSTEM_NAME}" STREQUAL "Darwin")

set (LIBUSRP_INCLUDE_DIR "fallback/")
include_directories(${LIBUSRP_INCLUDE_DIR})


include_directories(${CMAKE_SOURCE_DIR})

#add_executable(debug debug.cpp iobase.cpp ioparport.cpp iodebug.cpp)

add_executable(bitparse bitrev.cpp bitfile.cpp bitparse.cpp)
add_executable(jedecparse  jedecparse.cpp jedecfile.cpp)
add_executable(srecparse  srecparse.cpp srecfile.cpp)
add_executable(avrfuseparse  avrfuseparse.cpp avrfusefile.cpp)

ADD_CUSTOM_COMMAND(OUTPUT devices.h
    COMMAND ${CMAKE_COMMAND} -DDEVLIST_DIR=${CMAKE_SOURCE_DIR} -P ${CMAKE_SOURCE_DIR}/devlist.cmk
    DEPENDS devlist.txt
)

ADD_CUSTOM_COMMAND(OUTPUT cables.h
    COMMAND ${CMAKE_COMMAND} -DCABLELIST_DIR=${CMAKE_SOURCE_DIR} -P ${CMAKE_SOURCE_DIR}/cablelist.cmk
    DEPENDS cablelist.txt
)

INCLUDE_DIRECTORIES(BEFORE ${CMAKE_CURRENT_BINARY_DIR})

add_library(xc3sproglib  STATIC ioftdi.cpp iofx2.cpp
                      devicedb.cpp jtag.cpp jedecfile.cpp bitfile.cpp
			iobase.cpp  progalgxc95x.cpp utilities.cpp
			progalgxcf.cpp progalgxcfp.cpp progalgxc3s.cpp
			progalgavr.cpp progalgxc2c.cpp  mapfile_xc2c.cpp
			ioxpc.cpp progalgspiflash.cpp bitrev.cpp
                        cabledb.cpp pdioverjtag.cpp xmega_pdi_nvm.cpp
                        ${CONDITIONAL_FILES} devices.h cables.h)

add_executable(xc2c_warp xc2c_warp.cpp)
target_link_libraries(xc2c_warp xc3sproglib ${CONDITIONAL_LIBS})

add_executable(detectchain detectchain.cpp cables.h devices.h)
target_link_libraries(detectchain xc3sproglib ${LIBFTDI_LIBRARIES} ${LIBFTD2XX_LIBRARIES} ${CONDITIONAL_LIBS})

add_executable(xc3sprog xc3sprog.cpp javr.cpp srecfile.cpp progalgavr.cpp
			devices.h)
target_link_libraries(xc3sprog xc3sproglib ${LIBFTDI_LIBRARIES}  ${LIBFTD2XX_LIBRARIES} ${CONDITIONAL_LIBS}  )

add_executable(readdna readdna.cpp devices.h)
target_link_libraries(readdna xc3sproglib ${LIBFTDI_LIBRARIES}  ${LIBFTD2XX_LIBRARIES} ${CONDITIONAL_LIBS}  )

add_subdirectory(javr)

install(TARGETS xc3sprog DESTINATION bin)
install(TARGETS xc2c_warp DESTINATION bin)
install(TARGETS readdna DESTINATION bin)
install(TARGETS bitparse DESTINATION bin)
install(TARGETS jedecparse DESTINATION bin)
install(TARGETS srecparse DESTINATION bin)
install(TARGETS detectchain DESTINATION bin)
add_subdirectory(packages)
include(CPack)


SET_DIRECTORY_PROPERTIES(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${GENERATED_FILES}")

=== javr/CMakeLists.txt ===
# Project
project(javr)
SET(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}")
cmake_minimum_required(VERSION 2.6)

include_directories (${XC3SPROG_SOURCE_DIR})
link_directories (${XC3SPROG_BINARY_DIR}/xc3sproglib)

add_executable(javr   javr.cpp srecdec.cpp parse.cpp  menu.cpp
		    avr_jtag.cpp fuse.cpp jtag.cpp)
target_link_libraries(javr xc3sproglib ${LIBFTDI_LIBRARIES} ${LIBFTD2XX_LIBRARIES} ${CONDITIONAL_LIBS})
install(TARGETS javr DESTINATION bin)

=== packages/CMakeLists.txt ===
# Debian
if("${PACKAGE}" STREQUAL "Debian")

   # Settings
   set(REVISION                           0)
   set(CPACK_GENERATOR                    "DEB" PARENT_SCOPE)
   set(CPACK_PACKAGE_VERSION              ${CPACK_PACKAGE_VERSION}-${REVISION} PARENT_SCOPE)

   # Dependencies
   set(CPACK_DEBIAN_PACKAGE_DEPENDS       "libusb-0.1-4" PARENT_SCOPE)
   set(DEBIAN_PACKAGE_BUILDS_DEPENDS      "cmake, libusb-dev" PARENT_SCOPE)

endif("${PACKAGE}" STREQUAL "Debian")

# General RPM rules
set(CPACK_RPM_PACKAGE_DEPENDS       "libusb" "libftdi" PARENT_SCOPE)

## xc3sprog 0%2Bsvn795%2Bdfsg

=== debian/control ===
Source: xc3sprog
Section: electronics
Priority: optional
Maintainer: Ricardo Ribalda Delgado <ricardo@ribalda.com>
Build-Depends: cmake, debhelper (>= 11), libftdi1-dev, libusb-dev, pkg-config
Standards-Version: 4.2.1
Homepage: http://xc3sprog.sourceforge.net/
Vcs-Browser: https://sourceforge.net/p/xc3sprog/code/HEAD/tree/
Vcs-Svn: https://svn.code.sf.net/p/xc3sprog/code/
Rules-Requires-Root: no

Package: xc3sprog
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: JTAG flashing tool for FPGAs, CPLDs and EEPROMs
 xc3sprog is a suite of utilities for programming Xilinx FPGAs, CPLDs, and
 EEPROMs with the Xilinx Parallel Cable and other JTAG adapters under Linux.
 xc3sprog runs as a command-line application.
 .
 The main features include:
  - Reading a .BIT file from Xilinx design tools and programming it into an
    FPGA.
  - Reading a JEDEC file and programming it into a CPLD.
  - Programming a .BIT file into an on-board configuration PROM.
  - Programming a binary image into on-board SPI flash memory.
  - Reading the contents of a PROM chip back to a file.
  - Programming AVR microcontrollers.
 .
 The functionality of xc3sprog is similar to that of Xilinx IMPACT. There are
 also similarities with other free JTAG tools, such as UrJTAG. However,
 xc3sprog has a number of advantages:
 .
  - xc3sprog is free software.
  - It is a command-line tool.
  - It works on Linux without the need to install binary "cable-drivers".
    (Although some types of JTAG cables need to load firmware.)
  - It uses an optional configuration file to recognize new JTAG devices.
  - It contains programming algorithms for the supported devices, enabling
    the direct use of binary files (.BIT / JEDEC) from design tools (as opposed
    to intermediate SVF/STAPLE files).

## xc3sprog 0+svn795+dfsg

=== debian/changelog ===
xc3sprog (0+svn795+dfsg-5) unstable; urgency=medium

  * Fix build with cmake4 (Closes: #1113638)
  * pkg-config -> pkgconf
  * Bump Standards-Version
  * Add no-manual-page to lintian-overrides
  * Change email
  * Remove redundant rules-requires-root
  * Update debian/watch file
  * Add more security options
  * Change architecture to be Linux only

 -- Ricardo Ribalda Delgado <ribalda@debian.org>  Tue, 07 Oct 2025 08:15:54 +0000

xc3sprog (0+svn795+dfsg-4) unstable; urgency=medium

  * Fix build with gcc-11 (Closes: #984412)

 -- Ricardo Ribalda Delgado <ricardo@ribalda.com>  Thu, 04 Mar 2021 19:48:47 +0100

xc3sprog (0+svn795+dfsg-3) unstable; urgency=medium

  * Add debian/watch
  * CMakeLists.txt: Revert change by FORTIFY_SOURCE
  * xc2c_warp: Spell check
  * debian/control: wrap and sort
  * debian/control: update debhelper compat to 13
  * debian/control: bump standards-version, no changes
  * debian/rules: Add hardening options

 -- Ricardo Ribalda Delgado <ricardo@ribalda.com>  Fri, 05 Jun 2020 09:05:45 +0200

xc3sprog (0+svn795+dfsg-2) unstable; urgency=medium

  * debian/copyright: use spaces rather than tabs to start continuation
    lines.
  * Bump debhelper from old 11 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Set field Upstream-Contact in debian/copyright.
  * Changed vcs type from Svn to Git based on URL.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata
    (already present in machine-readable debian/copyright).
  * Update salsa CI file
  * Enable -D_FORTIFY_SOURCE=2

 -- Ricardo Ribalda Delgado <ricardo@ribalda.com>  Mon, 11 May 2020 11:41:27 +0200

xc3sprog (0+svn795+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #639956)
  * Enable CI for salsa
  * Fix copyright

 -- Ricardo Ribalda Delgado <ricardo@ribalda.com>  Mon, 14 Jan 2019 11:03:00 +0100

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,20 @@
 Source: xc3sprog
 Section: electronics
 Priority: optional
-Maintainer: Ricardo Ribalda Delgado <ricardo@ribalda.com>
-Build-Depends: cmake, debhelper (>= 11), libftdi1-dev, libusb-dev, pkg-config
-Standards-Version: 4.2.1
+Maintainer: Ricardo Ribalda Delgado <ribalda@debian.org>
+Build-Depends: cmake,
+               debhelper-compat (= 13),
+               libftdi1-dev,
+               libusb-dev,
+               pkgconf
+Standards-Version: 4.7.2
 Homepage: http://xc3sprog.sourceforge.net/
-Vcs-Browser: https://sourceforge.net/p/xc3sprog/code/HEAD/tree/
-Vcs-Svn: https://svn.code.sf.net/p/xc3sprog/code/
-Rules-Requires-Root: no
+Vcs-Browser: https://salsa.debian.org/ribalda-guest/xc3sprog
+Vcs-Git: https://salsa.debian.org/ribalda-guest/xc3sprog.git
 
 Package: xc3sprog
-Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Architecture: linux-any
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: JTAG flashing tool for FPGAs, CPLDs and EEPROMs
  xc3sprog is a suite of utilities for programming Xilinx FPGAs, CPLDs, and
  EEPROMs with the Xilinx Parallel Cable and other JTAG adapters under Linux.

=== debian/watch ===
version: 5

Source: svn://svn.code.sf.net/p/xc3sprog/code/trunk
Matching-Pattern: HEAD
Compression: xz
Dversionmangle: s/\+dfsg(\.?\d+)?$//
Mode: svn
Repack: yes
Uversionmangle: s/^0.0~/0\+/
